"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const cli_utils_1 = require("@ionic/cli-utils");
const build_1 = require("./build");
const generate_1 = require("./generate");
const serve_1 = require("./serve");
exports.version = '0.0.6-alpha.d32d569c';
function registerEvents(emitter) {
    emitter.on('docs', () => __awaiter(this, void 0, void 0, function* () {
        const appDirectory = '.'; // TODO: change this
        const ionicAngularPackageJson = yield cli_utils_1.readPackageJsonFile(path.resolve(appDirectory, 'node_modules', 'ionic-angular', 'package.json')); // TODO
        const docsHomepage = 'https://ionicframework.com/docs';
        const version = ionicAngularPackageJson.version;
        const url = `${docsHomepage}/${version}/api`;
        return url;
    }));
    emitter.on('generate', (args) => __awaiter(this, void 0, void 0, function* () {
        yield generate_1.generate(args);
    }));
    emitter.on('info', () => __awaiter(this, void 0, void 0, function* () {
        const appDirectory = '.'; // TODO: change this
        const ionicAngularPackageJson = yield cli_utils_1.readPackageJsonFile(path.resolve(appDirectory, 'node_modules', 'ionic-angular', 'package.json')); // TODO
        const appScriptsPackageJson = yield cli_utils_1.readPackageJsonFile(path.resolve(appDirectory, 'node_modules', '@ionic', 'app-scripts', 'package.json')); // TODO
        return [
            { type: 'local-npm', name: 'Ionic Framework', version: `ionic-angular ${ionicAngularPackageJson.version}` },
            { type: 'local-npm', name: '@ionic/cli-plugin-ionic-angular', version: exports.version },
            { type: 'local-npm', name: '@ionic/app-scripts', version: appScriptsPackageJson.version },
        ];
    }));
    emitter.on('serve', (args) => __awaiter(this, void 0, void 0, function* () {
        return serve_1.serve(args);
    }));
    emitter.on('build', (args) => __awaiter(this, void 0, void 0, function* () {
        yield build_1.build(args);
    }));
}
exports.registerEvents = registerEvents;
